verbose on

# Get install dir.
GetRegistryValue installdir=HKEY_LOCAL_MACHINE\SOFTWARE\OpeniT\Resources\InstallDir

# Check version.
versionCheck %installdir%\Configuration\version=4.9*,5.0*,5.1*,5.2*,5.3*

die off

# Stop service + recorder
SetRegistryValue HKEY_LOCAL_MACHINE\SOFTWARE\OpeniT\Resources\SentinelMarker=2
SetRegistryValue HKEY_LOCAL_MACHINE\SOFTWARE\OpeniT\Resources\Recorder\SentinelMarker=2
SetRegistryValue HKEY_LOCAL_MACHINE\SOFTWARE\OpeniT\Recorder\SentinelMarker=2
system net stop openit

# Wait for 20 seconds, to be sure all instances has ended
system "%installdir%\bin\sendcommand.exe" -h sentinel_%USERNAME% -c DIE
sleep 5000

system "%installdir%\bin\sendcommand.exe" -h recorder_%USERNAME% -c DIE
sleep 5000

print Will sleep for 10 seconds to make sure all instances of Recorder has ended
sleep 10000

# Backup PSAPI and PDH DLL's, if found
if ( exists == "%WINDIR%\system32\psapi.dll" ) if ( exists == "%installdir%\bin\psapi.dll" ) system move /Y "%installdir%\bin\psapi.dll" "%installdir%\bin\psapi.dll.bak"
if ( exists == "%WINDIR%\system32\pdh.dll" ) if ( exists == "%installdir%\bin\pdh.dll" ) system move /Y "%installdir%\bin\pdh.dll" "%installdir%\bin\pdh.dll.bak"

# Backup current binaries
system move /Y "%installdir%\bin\AppUsage.exe" "%installdir%\bin\AppUsage.exe.bak"
system move /Y "%installdir%\bin\WinSAR.exe" "%installdir%\bin\WinSAR.exe"
system move /Y "%installdir%\bin\OpeniTSentinel.exe" "%installdir%\bin\OpeniTSentinel.exe.bak"
system move /Y "%installdir%\bin\Recorder.exe" "%installdir%\bin\Recorder.exe.bak"
system move /Y "%installdir%\bin\RecorderDll.dll" "%installdir%\bin\RecorderDll.dll.bak"

# Copy new binaries.
if ( osversion < 51 ) system copy "bin\AppUsageW2K.exe" "%installdir%\bin\AppUsage.exe"
if ( osversion >= 51 ) system copy "bin\AppUsage.exe" "%installdir%\bin\"
system copy "bin\WinSAR.exe" "%installdir%\bin\"
system copy "bin\OpeniTSentinel.exe" "%installdir%\bin\"
system copy "bin\Recorder.exe" "%installdir%\bin\"
system copy "bin\RecorderDll.dll" "%installdir%\bin\"


# Force 1 hour interval for recorder
system ConfInit.exe -v 1 -c "appusage.interval=P1H"

# Enable recorder again
SetRegistryValue HKEY_LOCAL_MACHINE\SOFTWARE\OpeniT\Resources\SentinelMarker=1
SetRegistryValue HKEY_LOCAL_MACHINE\SOFTWARE\OpeniT\Resources\Recorder\SentinelMarker=1
SetRegistryValue HKEY_LOCAL_MACHINE\SOFTWARE\OpeniT\Recorder\SentinelMarker=1

# Copy readme.
if ( exists != "%installdir%\patches" ) system mkdir "%installdir%\patches"
system copy "readme.txt" "%installdir%\patches\1082.readme.txt"

# Start service again.
system net start openit

# Restart OpenitSentinel/Recorder
sleep 10000
run "%installdir%\bin\OpeniTSentinel.exe"
